package gz.cyberbrain.cyberhotel.controller;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BankWithClientsException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class BankListAdapter extends ListAdapter {

	public SaveAdapter getCreator(){
		return new BankCreator();
	}
	
	public SaveAdapter getUpdater() {
		return new BankUpdater();
	}
	
	public Vector load() {

		Vector list = new Vector();

		try {
			list = BankController.bankList();
		} catch (InternalErrorException e) {}

		return list;
	}

	public void delete(Serializable id) {

		try {
			BankController.deleteBank((Long) id);
		} catch (InstanceNotFoundException e) {
		} catch (BankWithClientsException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InternalErrorException e) {
		}

	}
	
	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = BankController.findBank((Long) id);
		} catch (InstanceNotFoundException e) {
        } catch (InternalErrorException e) {}
        return map;
	}

}
