package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BoardInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BoardTariffiedException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class BoardListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new BoardCreator();
	}

	public SaveAdapter getUpdater() {
		return new BoardUpdater();
	}

	public Vector load() {
		Vector list = new Vector();

		try {
			list = BoardController.boardList();
		} catch (InternalErrorException e) {}

		return list;
	}

	public void delete(Serializable id) {

		try {
			BoardController.deleteBoard((String) id);
		} catch (BoardInUseException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (BoardTariffiedException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InstanceNotFoundException e) {		
		} catch (InternalErrorException e) {
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();

		map = BoardController.findBoard((String) id);

		return map;
	}

}
