package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.EmployeeWithWashesException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class EmployeeListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new EmployeeCreator();
	}

	public SaveAdapter getUpdater() {
		return new EmployeeUpdater();
	}

	public Vector load() {
		Vector list = new Vector();

		list = EmployeeController.employeeList();

		return list;
	}

	public void delete(Serializable id) {

		try {
			EmployeeController.deleteEmployee((Long) id);
		} catch (EmployeeWithWashesException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("employeeWithWashes"));
		}catch (InstanceNotFoundException e) {		
		} catch (InternalErrorException e) {} 

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = EmployeeController.findEmployee((Long) id);
		} catch (InstanceNotFoundException e) {
		} catch (InternalErrorException e) {}
		return map;
	}

}
