package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.address.dao.AddressDao;
import gz.cyberbrain.cyberhotel.model.address.to.AddressTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.AddressInUseException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteAddressAction {

private AddressTo addressTo;
private AddressDao addressDao;
	
	public DeleteAddressAction (AddressTo addressTo, AddressDao addressDao) {
		
		this.addressTo = addressTo;
		this.addressDao = addressDao;
		
	}
	
	public void execute() throws AddressInUseException, InternalErrorException {	
		
		if (addressDao.existClients(addressTo.getAddressId(), addressTo.getCountry())) throw new AddressInUseException(addressTo);
		
		addressDao.remove(addressTo);
		
	}
	
}
