package gz.cyberbrain.cyberhotel.model.employee.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;
import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;
import gz.cyberbrain.cyberhotel.model.util.money.MoneyOperations;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;

public class EmployeeTo implements Identifiable {
	
	private static final long serialVersionUID = -8971779510954600677L;
	private Long employeeId;
	private String nif;
	private String name;
	private String firstSurname;
	private String secondSurname;
	private Calendar bornDate;
	private String sex;
	private String maritalStatus;
	private Long address;
	private String street;
	private String dwellingPlace;
	private String phone1;
	private String phone2;
	private String job;
	private Calendar hireDate;
	private BigDecimal salary;
	private String observations;
	
	public EmployeeTo(){}
	
	public EmployeeTo(Long employeeId, String nif, String name, String firstSurname, String secondSurname, Calendar bornDate, String sex, String maritalStatus, Long address, String street, String dwellingPlace, String phone1, String phone2, String job, Calendar hireDate, BigDecimal salary, String observations) {			
		this.employeeId = employeeId;
		this.nif = nif;
		this.name = name;
		this.firstSurname = firstSurname;
		this.secondSurname = secondSurname;
		this.bornDate = DateOperations.getDateWithoutMilliseconds(bornDate);
		this.sex = sex;
		this.maritalStatus = maritalStatus;
		this.address = address;
		this.street = street;
		this.dwellingPlace = dwellingPlace;
		this.phone1 = phone1;
		this.phone2 = phone2;
		this.job = job;
		this.hireDate = DateOperations.getDateWithoutMilliseconds(hireDate);
		this.salary = MoneyOperations.getDecimalReduction(salary);
		this.observations = observations;
	}
	
	public Serializable getId(){
		return employeeId;
	}

	public Long getAddress() {
		return address;
	}

	public void setAddress(Long address) {
		this.address = address;
	}

	public Calendar getBornDate() {
		return bornDate;
	}

	public void setBornDate(Calendar bornDate) {
		this.bornDate = bornDate;
	}

	public String getDwellingPlace() {
		return dwellingPlace;
	}

	public void setDwellingPlace(String dwellingPlace) {
		this.dwellingPlace = dwellingPlace;
	}

	public Long getEmployeeId() {
		return employeeId;
	}

	public void setEmployeeId(Long employeeId) {
		this.employeeId = employeeId;
	}

	public String getFirstSurname() {
		return firstSurname;
	}

	public void setFirstSurname(String firstSurname) {
		this.firstSurname = firstSurname;
	}

	public Calendar getHireDate() {
		return hireDate;
	}

	public void setHireDate(Calendar hireDate) {
		this.hireDate = hireDate;
	}

	public String getJob() {
		return job;
	}

	public void setJob(String job) {
		this.job = job;
	}

	public String getMaritalStatus() {
		return maritalStatus;
	}

	public void setMaritalStatus(String maritalStatus) {
		this.maritalStatus = maritalStatus;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getNif() {
		return nif;
	}

	public void setNif(String nif) {
		this.nif = nif;
	}

	public String getObservations() {
		return observations;
	}

	public void setObservations(String observations) {
		this.observations = observations;
	}

	public String getPhone1() {
		return phone1;
	}

	public void setPhone1(String phone1) {
		this.phone1 = phone1;
	}

	public String getPhone2() {
		return phone2;
	}

	public void setPhone2(String phone2) {
		this.phone2 = phone2;
	}

	public BigDecimal getSalary() {
		return salary;
	}

	public void setSalary(BigDecimal salary) {
		this.salary = salary;
	}

	public String getSecondSurname() {
		return secondSurname;
	}

	public void setSecondSurname(String secondSurname) {
		this.secondSurname = secondSurname;
	}

	public String getSex() {
		return sex;
	}

	public void setSex(String sex) {
		this.sex = sex;
	}

	public String getStreet() {
		return street;
	}

	public void setStreet(String street) {
		this.street = street;
	}

}
