package gz.cyberbrain.cyberhotel.model.price.dao;

import gz.cyberbrain.cyberhotel.model.price.to.PriceTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import java.io.Serializable;
import java.util.Collection;
import java.util.Iterator;

public class PriceSpringDao extends AbstractSpringDao implements PriceDao {

	public PriceSpringDao() {
		super(PriceTo.class);
	}	

	public void create(PriceTo priceTo) throws InternalErrorException {		

		super.save(priceTo);

	}

	public PriceTo find(Long priceId, String board, String priceType, Long season) throws InstanceNotFoundException, InternalErrorException {

		String queryName = "aPrice";
		Serializable []attributes = {priceId, board, priceType, season}; 
		Collection priceTo = super.findByAttributes(queryName,attributes);

		Exception e = new Exception("Price must be unique");

		if (priceTo.size() > 1) throw new InternalErrorException(e);
		if (priceTo.isEmpty()) throw new InstanceNotFoundException(attributes,PriceTo.class.getName());

		Iterator iter = priceTo.iterator();

		return (PriceTo) iter.next();

	}

	public void update(PriceTo priceTo) throws InternalErrorException {		

		super.update(priceTo);

	}

	public void remove(PriceTo priceTo) throws InternalErrorException {

		super.delete(priceTo);

	}

	public Collection findAll() throws InternalErrorException {

		String queryName = "allPrices";
		return super.findByQuery(queryName);

	}

	public Collection findBySeason(Long season) throws InternalErrorException {

		String queryName = "findBySeason";
		return super.findByAttribute(queryName, season);
	}

	public long maxId() throws InternalErrorException {

		String queryName = "nextId";
		Collection id = super.findByQuery(queryName);
		if (id.size() > 1) throw new InternalErrorException(new Exception());
		Iterator iter = id.iterator();		
		return ((Long) iter.next()).longValue();

	}

}
