package gz.cyberbrain.cyberhotel.model.pricetype.dao;

import gz.cyberbrain.cyberhotel.model.pricetype.to.PriceTypeTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class PriceTypeSpringDao extends AbstractSpringDao implements PriceTypeDao{

	public PriceTypeSpringDao() {
		super(PriceTypeTo.class);
	}	

	public PriceTypeTo create(PriceTypeTo prizeTypeTo) throws InternalErrorException {		

		return (PriceTypeTo) super.save(prizeTypeTo);

	}

	public PriceTypeTo find(String priceTypeCode) throws InstanceNotFoundException, InternalErrorException {

		PriceTypeTo priceTypeTo = (PriceTypeTo) super.find(priceTypeCode);
		return priceTypeTo;

	}

	public void update(PriceTypeTo prizeTypeTo) throws InternalErrorException {		

		super.update(prizeTypeTo);

	}

	public void remove(PriceTypeTo prizeTypeTo) throws InternalErrorException {

			super.delete(prizeTypeTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allPriceTypes";
		return super.findByQuery(queryName);
		
	}
	
	public Collection findAllCodes() throws InternalErrorException {
		
		String queryName = "allPriceTypeCodes";
		return super.findByQuery(queryName);
		
	}
	
	public boolean existRequests(String priceTypeCode) throws InternalErrorException {
		String queryName = "priceTypeRequests";
		return (!super.findByAttribute(queryName, priceTypeCode).isEmpty());
	}
	
	public boolean isTariffied(String priceTypeCode) throws InternalErrorException {
		String queryName = "priceTypePrices";
		return (!super.findByAttribute(queryName, priceTypeCode).isEmpty());
	}
	
}
