package gz.cyberbrain.cyberhotel.model.room.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;
import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;

import java.io.Serializable;
import java.util.Calendar;
/*import java.util.Collection;
import java.util.HashSet;*/

public class RoomTo implements Identifiable {
	
	private static final long serialVersionUID = 3466590423932570802L;
	private String roomCode;
	private String number;
	private long floor;
	private String type;
	private String occupancyStatus;
	private String cleaningStatus;
	private Calendar checkingDate;
	private boolean smokers;
	private long maxPax;
	private String notes;
//	private Collection boarders = new HashSet();
	
	public RoomTo(){}

	public RoomTo(String roomCode, String number, long floor, String type, String occupancyStatus, String cleaningStatus, Calendar checkingDate, boolean smokers, long maxPax, String notes) {
		super();
		this.roomCode = roomCode;
		this.number = number;
		this.floor = floor;
		this.type = type;
		this.occupancyStatus = occupancyStatus;
		this.cleaningStatus = cleaningStatus;
		this.checkingDate = DateOperations.getDateWithoutMilliseconds(checkingDate);
		this.smokers = smokers;
		this.maxPax = maxPax;
		this.notes = notes;
	}

	public Serializable getId(){
		return roomCode;
	}
/*
	public Collection getBoarders() {
		return boarders;
	}

	public void setBoarders(Collection boarders) {
		this.boarders = boarders;
	}
*/
	public Calendar getCheckingDate() {
		return checkingDate;
	}

	public void setCheckingDate(Calendar checkingDate) {
		this.checkingDate = checkingDate;
	}

	public String getCleaningStatus() {
		return cleaningStatus;
	}

	public void setCleaningStatus(String cleaningStatus) {
		this.cleaningStatus = cleaningStatus;
	}

	public long getFloor() {
		return floor;
	}

	public void setFloor(long floor) {
		this.floor = floor;
	}

	public long getMaxPax() {
		return maxPax;
	}

	public void setMaxPax(long maxPax) {
		this.maxPax = maxPax;
	}

	public String getNotes() {
		return notes;
	}

	public void setNotes(String notes) {
		this.notes = notes;
	}

	public String getNumber() {
		return number;
	}

	public void setNumber(String number) {
		this.number = number;
	}

	public String getOccupancyStatus() {
		return occupancyStatus;
	}

	public void setOccupancyStatus(String occupancyStatus) {
		this.occupancyStatus = occupancyStatus;
	}

	public String getRoomCode() {
		return roomCode;
	}

	public void setRoomCode(String roomCode) {
		this.roomCode = roomCode;
	}

	public boolean getSmokers() {
		return smokers;
	}

	public void setSmokers(boolean smokers) {
		this.smokers = smokers;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
	
		
}
