package gz.cyberbrain.cyberhotel.model.util.exceptions;

import java.util.Calendar;

public class InvalidIntervalException extends ModelException {
	
	private static final long serialVersionUID = -783662326582421255L;
	private Calendar start;
	private Calendar end;
	
    public InvalidIntervalException(Calendar start, Calendar end) {
    	super("Invalid Interval Definition: Start=" + start.get(Calendar.DATE)+"/"+start.get(Calendar.MONTH)+"/"+start.get(Calendar.YEAR) + 
    			" - End=" + end.get(Calendar.DATE)+"/"+end.get(Calendar.MONTH)+"/"+end.get(Calendar.YEAR));
    	this.start = start;
    	this.end = end;
    }
    
    public Calendar getStart() {
    	return start;
    }
    
    public Calendar getEnd() {
    	return end;
    }
	
}
