package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.text.MaskFormatter;

/** Mascara para fecha/hora a nuestro gusto */
public class DateFormat extends MaskFormatter
{

	private static final long serialVersionUID = 1L;

	/** Se construye con el patrn deseado */
	public DateFormat() throws ParseException
	{
		// Las # son cifras y representa "dd/mm/yy hh:mm:ss"
		super ("##/##/####");
	}

	/** Una clase adecuada para convertir Date a String y viceversa de forma cmoda. Puedes ver cmo se hace el patrn "dd/MM/yy kk:mm:ss" en la API.
        El patrn que pongamos aqu debe cuadrar correctamente con la mscara que hemos puesto en el constructor */
	private SimpleDateFormat formato = new SimpleDateFormat("dd/MM/yyyy");

	/** Convierte el texto del editor en un Date */
	public Object stringToValue(String text) throws ParseException
	{
		return formato.parseObject(text);
	}

	/** Redibe un Date o null y debe convertirlo a texto que cumpla el patrn indicado anteriormente */
	public String valueToString(Object value) throws ParseException
	{
		if (value instanceof Date)
			return formato.format((Date)value);
		return formato.format(new Date());
	}
}