package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import java.util.Vector;

import javax.swing.table.DefaultTableModel;

public class OwesTableModel extends DefaultTableModel {

	private static final long serialVersionUID = 1L;

	/** Vector of Object[], this are the data of the table */
	Object[][] data = new Object[0][0];    

	/** Indicates which columns are visible */
	boolean[] columnsVisible = new boolean[9];

	/** Column names */
	private String[] titles;

	/** Constructor */        
	public OwesTableModel(Object[][] data, String[] titles) {

		super(data, titles);		
		this.titles = titles;
		this.data = data;
		setVisibleColumns();
	}

	private void setVisibleColumns() {
		columnsVisible[0] = true;
		columnsVisible[1] = true;
		columnsVisible[2] = true;
		columnsVisible[3] = true;
		columnsVisible[4] = true;
		columnsVisible[5] = true;
		columnsVisible[6] = true;
		columnsVisible[7] = true;
		columnsVisible[8] = false;
		
	}


	/** 
	 * This function converts a column number in the table
	 * to the right number of the data.
	 */
	protected int getNumber (int col) {
		int n = col;    // right number to return
		int i = 0;
		do {
			if (!(columnsVisible[i])) n++;
			i++;
		} while (i < n);
		// If we are on an invisible column, 
		// we have to go one step further
		while (!(columnsVisible[n])) n++;
		return n;
	}


	// *** TABLE MODEL METHODS ***

	public int getColumnCount() {
		return super.getColumnCount();
	}

	public int getRowCount () {
		return super.getRowCount();
	}

	public void setData(Object[][] data) {
		this.data = data;
	}

	public int getDataRowCount() {
		return data.length;
	}

	public Object getCustomValueAt (int row, int column) {
		return data[row][column];
	}

	public String getColumnName (int column) {
		return titles[getNumber(column)];
	}

	public void addRow(Vector row){				
		super.addRow(row);
	}

	public void addDataRow(Object [] row) {

		if (data.length == 0) {

			Object[][] newData = new Object[data.length + 1][row.length];
			for (int j=0; j < row.length; j++) newData[0][j] = row[j];
			setData(newData);

		}

		if (data.length != 0 && row.length == data[0].length) {

			Object[][] newData = new Object[data.length + 1][data[0].length];

			for (int i=0; i<data.length; i++) {
				for (int j=0; j<data[0].length;j++) {

					newData[i][j] = data[i][j];

				}
			}

			for (int i=0; i<data[0].length;i++)
				newData[data.length][i] = row[i];

			setData(newData);

		}

	}

	public void removeDataRow(int row) {
	
		Object[][] newData = new Object[data.length - 1][data[0].length];

		int i = 0;
	
		while (i < row) {

			for (int j=0; j<data[0].length; j++) 
				newData[i][j] = data[i][j];	

			i++;

		}

		while (i < data.length - 1) {

			for (int j=0; j<data[0].length; j++)  
				newData[i][j] = data[i+1][j];

			i++;

		}

		setData(newData);

	}

}